#include <bits/stdc++.h>
#include <string>
using namespace std;



int main() {

    ios::sync_with_stdio(false);
    cin.tie(0);

    int m,n;
    cin>>m;
    cin>>n;

    string a;

    int steva=0;

    vector<int> vatra;

    char x;
    for(int i=0;i<n;i++){
        cin>>x;
        if(x=='S'){
            steva=i;
        }
        if(x=='X'){
            vatra.push_back(i);
        }
        a=a+x;
    }

    vector<int> vreme(n,INT_MAX);


    int t=0;

    vector<int> v_vreme(n,INT_MAX);

    for(int i=0;i<vatra.size();i++){
        for(int j=vatra[i];j<n;j++){
            if(a[j]=='X'){
                v_vreme[j]=min(j-vatra[i],v_vreme[j]);
            }else if(a[j]=='*'){
                break;
            }else{
                v_vreme[j]=min(j-vatra[i],v_vreme[j]);
            }
        }

        for(int j=vatra[i];j>=0;j--){
            if(a[j]=='X'){
                v_vreme[j]=min(vatra[i]-j,v_vreme[j]);
            }else if(a[j]=='*'){
                break;
            }else{
                v_vreme[j]=min(vatra[i]-j,v_vreme[j]);
            }

        }

    }

    for(int i=steva;i<n;i++){
        if(a[i]=='.'){
            vreme[i]=i-steva;
        }
        if(a[i]=='*'){
            break;
        }
        if(vreme[i]<v_vreme[i]){
            t++;
        }
    }
    for(int i=steva;i>=0;i--){
        if(a[i]=='.'){
            vreme[i]=steva-i;
        }
        if(a[i]=='*'){
            break;
        }
        if(a[i]=='S'){
            vreme[i]=0;
        }
        if(vreme[i]<v_vreme[i]){
            t++;
        }
    }

    cout<<t;





}